using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Data;
using System.Data.SqlClient;

using Microsoft.Synchronization;
using Microsoft.Synchronization.Data;

namespace SyncAdoDemo
{
    public partial class ProgressForm : Form
    {
        public ProgressForm()
        {
            InitializeComponent();
        }

        public void Report(SyncProgressEventArgs args)
        {
            string message = "Progress: ";
            
            switch(args.SyncStage)
            {
                case SyncStage.ApplyingInserts:
                    message += "Applying insert for table: " + args.TableMetadata.TableName;
                    message += "[" + args.TableProgress.Inserts.ToString() + "|" + args.TableProgress.Updates.ToString() + "|" + args.TableProgress.Deletes.ToString() + "]";
                    message += "(Applied:" + args.TableProgress.ChangesApplied.ToString() + "/Pending:" + args.TableProgress.ChangesPending.ToString() + 
                       "/Failed:" + args.TableProgress.ChangesFailed.ToString() + "/Total:" + args.TableProgress.TotalChanges.ToString() + ")";
                break;    

                case SyncStage.ApplyingUpdates:
                    message += "Applying update for table: " + args.TableMetadata.TableName;
                    message += "[" + args.TableProgress.Inserts.ToString() + "|" + args.TableProgress.Updates.ToString() + "|" + args.TableProgress.Deletes.ToString() + "]";
                    message += "(Applied:" + args.TableProgress.ChangesApplied.ToString() + "/Pending:" + args.TableProgress.ChangesPending.ToString() +
                        "/Failed:" + args.TableProgress.ChangesFailed.ToString() + "/Total:" + args.TableProgress.TotalChanges.ToString() + ")"; 
                break;

                case SyncStage.ApplyingDeletes:
                    message += "Applying delete for table: " + args.TableMetadata.TableName;
                    message += "[" + args.TableProgress.Inserts.ToString() + "|" + args.TableProgress.Updates.ToString() + "|" + args.TableProgress.Deletes.ToString() + "]";
                    message += "(Applied:" + args.TableProgress.ChangesApplied.ToString() + "/Pending:" + args.TableProgress.ChangesPending.ToString() +
                        "/Failed:" + args.TableProgress.ChangesFailed.ToString() + "/Total:" + args.TableProgress.TotalChanges.ToString() + ")";
                break;
                
                case SyncStage.GettingInserts:
                    message += "Enumerating inserts for table: " + args.TableMetadata.TableName;
                    message += "[" + args.TableProgress.Inserts.ToString() + "|" + args.TableProgress.Updates.ToString() + "|" + args.TableProgress.Deletes.ToString() + "]";                    
                break;
            
                case SyncStage.GettingUpdates:
                    message += "Enumerating updates for table: " + args.TableMetadata.TableName;
                    message += "[" + args.TableProgress.Inserts.ToString() + "|" + args.TableProgress.Updates.ToString() + "|" + args.TableProgress.Deletes.ToString() + "]";                    
                break;

                case SyncStage.GettingDeletes:
                    message += "Enumerating deletes for table: " + args.TableMetadata.TableName;
                    message += "[" + args.TableProgress.Inserts.ToString() + "|" + args.TableProgress.Updates.ToString() + "|" + args.TableProgress.Deletes.ToString() + "]";                    
                break;
            }
            
            listSyncProgress.Items.Add(message);
            Application.DoEvents();
        }

        public void EnableClose()
        {
            buttonClose.Enabled = true;
            Application.DoEvents();
        }

        private void buttonClose_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void ProgressForm_Shown(object sender, EventArgs e)
        {            
        }
    }
}